-- local AceGUI = LibStub("AceGUI-3.0")
Alert = LibStub("AceAddon-3.0"):NewAddon("Alert", "AceConsole-3.0", "AceEvent-3.0")
-- AceEvent:Embed(Alert)

-- Local variables for fun and profit!!!

local Setup = nil
local SpellSetup = nil
local ProcEntryTable = {}
local SpellEntryTable = {}
local BuffEntryTable = {}
local SpellEntryTextTable = {}
local BuffEntryTextTable = {}
local ProcEntryTextTable = {}
local ProcEntryTextRightTable = {}
local SelectedEntry = nil
local SpellSelectedEntry = nil
local defaults = {
    profile = {
		Options = {
			ProcSound = "Interface\\AddOns\\Alert\\Sounds\\soundclip.mp3",
			Icon = true,
			SpellIcon = true,
			IconScale = 1,
			IconOpacity = 1,
			Text = true,
			Sound = true,
			IconLock = false,
			CustomSound = nil,
			Timer = true,
		}
	}
}
Sounds = {}
Sounds["Interface\\AddOns\\Alert\\Sounds\\soundclip.mp3"] = "Defualt"
Sounds["Sound\\interface\\PlaceHolder.wav"] = "Beep"
Sounds["Sound\\interface\\AuctionWindowOpen.wav"] = "Ding"
Sounds["nil"] = "Custom" -- "Interface\\AddOns\\Alert\\Sounds\\"

local options = {
    name = "Alert",
	childGroups = "tab",
    handler = Alert,
    type = 'group',
    args = {
		Toggles = {
		order = 1,
		name = "Options",
		type = 'group',
		args = {
			BuffConfig = {
				order = 0,
				name = "Buffs",
				desc = "Buffs to look for",
				type = "execute",
				width = "half",
				func = function() Alert_BuffFrame:Show() end
				},
			SpellConfig = {
				order = 1,
				name = "Spell",
				desc = "Spells to show when available",
				type = "execute",
				width = "half",
				func = function() Alert_SpellFrame:Show() end
				},
			Reset = {
				order = 2,
				name = "Reset",
				desc = "Resets icon possition",
				type = "execute",
				width = "half",
				func = function() Alert:Reset() end
				},
			Text = {
				name="Text",
				order = 3,
				desc = "Toggles the displaying of a text notification",
				type = "toggle",
				set = function(info,val) Alert.db.profile.Options.Text = val end,
				get = function(info) return Alert.db.profile.Options.Text end
				},
			Sound = {
				name = "Sound",
				order = 4,
				desc = "Toggles the displaying of a sound notification",
				type = "toggle",
				set = function(info,val) Alert.db.profile.Options.Sound = val end,
				get = function(info) return Alert.db.profile.Options.Sound end
				},
			Timer = {
				name = "Timer",
				order = 5,
				desc = "Toggles the displaying of timer text",
				type = "toggle",
				set = function(info,val) Alert.db.profile.Options.Timer = val end,
				get = function(info) return Alert.db.profile.Options.Timer end
				},
			BuffIcon={
				name = "Buff Icons",
				order = 6,
				desc = "Toggles the displaying of a Buff Icon notification",
				type = "toggle",
				set = function(info,val) Alert.db.profile.Options.Icon = val end,
				get = function(info) return Alert.db.profile.Options.Icon end
				},
			SpellIcon={
				name = "Spell Icons",
				order = 7,
				desc = "Toggles the displaying of a Spell Icon notification",
				type = "toggle",
				set = function(info,val) Alert.db.profile.Options.SpellIcon = val end,
				get = function(info) return Alert.db.profile.Options.SpellIcon end
				},
			IconLock = {
				name = "Lock Icons",
				order = 8,
				desc = "Locks and Unlocks Icon Position",
				type = "toggle",
				set = function(info,val) Alert.db.profile.Options.IconLock = val if val == true then Alert_Texture:Hide() Alert_UsableTexture:Hide() Alert_IconTemplate:EnableMouse(false) else Alert_Texture:Show() Alert_UsableTexture:Show() Alert_IconTemplate:EnableMouse(true) end end,
				get = function(info) return Alert.db.profile.Options.IconLock end
				},
			IconScale = {
				name = "Icon Scale",
				order = 9,
				desc = "Changes the scale of icons",
				type = "range",
				min = 0.1,
				max = 2,
				step = 0.1,
				set = function(info,val) Alert.db.profile.Options.IconScale = val Alert_IconTemplate:SetScale(val) end,
				get = function(info) return Alert.db.profile.Options.IconScale end
				},
			IconOpacity = {
				name = "Icon Opacity",
				order = 10,
				desc = "Changes the opacity of icons",
				type = "range",
				min = 0,
				max = 1,
				step = 0.05,
				set = function(info,val) Alert.db.profile.Options.IconOpacity = val Alert_IconTemplate:SetAlpha(val) end,
				get = function(info) return Alert.db.profile.Options.IconOpacity end
				},
			ProcSound = {
				name = "Sound",
				order = 11,
				desc = "Selects the sound to be played",
				type = "select",
				style = "radio",
				values = Sounds,
				get = function(info) return Alert.db.profile.Options.ProcSound end,
				set = function(info,key) if Sounds[key] ~= "Custom" then Alert.db.profile.Options.ProcSound = key else Alert.db.profile.Options.ProcSound = "Interface\\AddOns\\Alert\\Sounds\\"..Alert.db.profile.Options.CustomSound end PlaySoundFile(Alert.db.profile.Options.ProcSound) end
				},
			SoundBox = {
				name = "Custom Sound",
				order = 12,
				desc = "Imput the name of a custom sound to play",
				type = "input",
				usage = "Sound File name including extension",
				set = function(info,val) Alert.db.profile.Options.CustomSound = val end,
				get = function(info) return Alert.db.profile.Options.CustomSound end
				},
			}
		}
	}
}

function Alert:OnEnable()
    -- Called when the addon is enabled
	self:RegisterEvent("UNIT_AURA")
	-- self:RegisterEvent("SPELL_UPDATE_COOLDOWN")
end

function Alert:OnDisable()
    -- Called when the addon is disabled, here incase I ever feel like putting something in to allow such a thing
end

function Alert:Reset()
	-- Called when reset button is pressed, it resets the position of the icon clustre to the center of the screen, le gasp I bet you were surprised thats what this did!
	Alert_IconTemplate:ClearAllPoints()
	Alert_IconTemplate:SetPoint("CENTER", UIParent, "CENTER", 0,0)
	-- Alert_IconUsableTemplate:ClearAllPoints()
	-- Alert_IconUsableTemplate:SetPoint("CENTER", UIParent, "CENTER", 0,-30)
end

function Alert:OnInitialize()
    -- Called when the addon is loaded
	local AceGUI = LibStub("AceGUI-3.0")
	self.db = LibStub("AceDB-3.0"):New("AlertDB", defaults, "Default")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Alert", options, {"Alert"})
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Alert", "Alert")
	self:RegisterChatCommand("Alert", "ChatCommand")
	
	TextureList = {}
	FontList = {}
	FrameList = {}
	Alert_Played = {} 
	if Alert_SpellList == nil then
		Alert_SpellList = {}
	end
	if Alert_ProcList == nil then
		Alert_ProcList = {
			"Missile Barrage",
			"Fingers of Frost",
			"Fireball!",
			"Hot Streak",
			"Surge of Light",
			"Sudden Death",
			"Surge of Light",
			"Slam!",
			"Sword and Board",
			"Lock and Load",
			"Shadow Trance",
			"Backlash",
			"Rime",
			"The Art Of War",
		}
	end
	if Alert_Sound == nil then
		Alert_Sound = {}
		for k,v in pairs(Alert_ProcList) do 
			Alert_Sound[k] = true
		end
	end
	
	Alert:SetUpBuffListFrame()
	Alert:SetUpSpellListFrame()
	Alert:SetUpIconFrames()
	Alert:SetUpUsableIconFrames()
	
	Alert_IconTemplate:SetScale(self.db.profile.Options.IconScale)
	Alert_IconTemplate:SetAlpha(self.db.profile.Options.IconOpacity)
	if self.db.profile.Options.IconLock == true then
		Alert_Texture:Hide()
		Alert_UsableTexture:Hide()
		Alert_IconTemplate:EnableMouse(false)
	else
		Alert_Texture:Show()
		Alert_UsableTexture:Show()
		Alert_IconTemplate:EnableMouse(true)
	end
	
	for k,v in pairs(Alert_ProcList) do
		Alert_Played[v] = false
	end

	Alert:Constructor()
end

function Alert:Constructor()
	local FrameBackdrop = {
		bgFile="Interface\\AddOns\\PPC\\UI-DialogBox-Background",
		edgeFile="Interface\\AddOns\\PPC\\UI-DialogBox-Border", 
		tile = true, tileSize = 32, edgeSize = 32, 
		insets = { left = 8, right = 8, top = 8, bottom = 8 }
	}

	local PaneBackdrop  = {
		bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
		edgeFile = "Interface\\AddOns\\PPC\\UI-Tooltip-Border",
		tile = true, tileSize = 16, edgeSize = 16,
		insets = { left = 3, right = 3, top = 5, bottom = 3 }
	}
	
	local frame = CreateFrame("Frame","Alert_BuffFrame",UIParent)
	frame:SetWidth(250)
	frame:SetHeight(350)
	frame:SetPoint("CENTER",UIParent,"CENTER",0,0)
	frame:EnableMouse()
	frame:SetMovable(true)
	frame:SetResizable(true)
	frame:SetFrameStrata("FULLSCREEN_DIALOG")
	
	frame:SetBackdrop(FrameBackdrop)
	frame:SetBackdropColor(0,0,0,1)
	frame:SetMinResize(250,350)
	frame:SetToplevel(true)
	
	local closebutton = CreateFrame("Button", "Alert_BuffClose",frame,"UIPanelButtonTemplate")
	closebutton:SetScript("OnClick", function() Alert_BuffFrame:Hide() end)
	closebutton:SetPoint("BOTTOMRIGHT",frame,"BOTTOMRIGHT",-27,17)
	closebutton:SetHeight(20)
	closebutton:SetWidth(100)
	closebutton:SetText(CLOSE)
	
	local removebutton = CreateFrame("Button",nil,frame,"UIPanelButtonTemplate")
	removebutton:SetScript("OnClick", function() Alert:Remove() end)
	removebutton:SetPoint("BOTTOMRIGHT",frame,"BOTTOMRIGHT",-27,39)
	removebutton:SetHeight(20)
	removebutton:SetWidth(100)
	removebutton:SetText("Remove")
	
	local editbox = CreateFrame("EditBox", Alert_EditBox, frame, "InputBoxTemplate")
	editbox:SetPoint("BOTTOMLEFT",frame,"BOTTOMLEFT",22,39)
	editbox:SetPoint("BOTTOMRIGHT",frame,"BOTTOMRIGHT",-133,39)
	editbox:SetHeight(20)
	editbox:SetAutoFocus(false)
	editbox:SetScript("OnEscapePressed", function() editbox:ClearFocus() end)
	editbox:SetScript("OnEnterPressed", function() local val = editbox:GetText() editbox:SetText("") editbox:ClearFocus() if val ~= "" then return Alert:ProcEntry(val) end end)
	
	local statusbg = CreateFrame("Frame",nil,frame)
	statusbg:SetPoint("BOTTOMLEFT",frame,"BOTTOMLEFT",15,15)
	statusbg:SetPoint("BOTTOMRIGHT",frame,"BOTTOMRIGHT",-132,15)
	statusbg:SetHeight(24)
	statusbg:SetBackdrop(PaneBackdrop)
	statusbg:SetBackdropColor(0.1,0.1,0.1)
	statusbg:SetBackdropBorderColor(0.4,0.4,0.4)

	local statustext = statusbg:CreateFontString(nil,"OVERLAY","GameFontNormal")
	statustext:SetPoint("TOPLEFT",statusbg,"TOPLEFT",7,-2)
	statustext:SetPoint("BOTTOMRIGHT",statusbg,"BOTTOMRIGHT",-7,2)
	statustext:SetHeight(20)
	statustext:SetJustifyH("LEFT")
	statustext:SetText("")
	
	local title = CreateFrame("Frame",nil,frame)
	title:EnableMouse()
	title:SetScript("OnMouseDown", function() frame:StartMoving() end)
	title:SetScript("OnMouseUp", function() frame:StopMovingOrSizing() end)
	
	
	local titlebg = frame:CreateTexture(nil,"OVERLAY")
	titlebg:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header")
	titlebg:SetTexCoord(0.31,0.67,0,0.63)
	titlebg:SetPoint("TOP",frame,"TOP",0,12)
	titlebg:SetWidth(100)
	titlebg:SetHeight(40)

	local titlebg_l = frame:CreateTexture(nil,"OVERLAY")
	titlebg_l:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header")
	titlebg_l:SetTexCoord(0.21,0.31,0,0.63)
	titlebg_l:SetPoint("RIGHT",titlebg,"LEFT",0,0)
	titlebg_l:SetWidth(30)
	titlebg_l:SetHeight(40)
	
	local titlebg_right = frame:CreateTexture(nil,"OVERLAY")
	titlebg_right:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header")
	titlebg_right:SetTexCoord(0.67,0.77,0,0.63)
	titlebg_right:SetPoint("LEFT",titlebg,"RIGHT",0,0)
	titlebg_right:SetWidth(30)
	titlebg_right:SetHeight(40)
	
	title:SetAllPoints(titlebg)			
	local titletext = title:CreateFontString(nil,"OVERLAY","GameFontNormal")
	titletext:SetPoint("TOP",titlebg,"TOP",0,-14)
	titletext:SetText("Buffs")
	
	local sizer_se = CreateFrame("Frame",nil,frame)
	sizer_se:SetPoint("BOTTOMRIGHT",frame,"BOTTOMRIGHT",0,0)
	sizer_se:SetWidth(25)
	sizer_se:SetHeight(25)
	sizer_se:EnableMouse()
	sizer_se:SetScript("OnMouseDown", function() frame:StartSizing() end)
	sizer_se:SetScript("OnMouseUp", function() frame:StopMovingOrSizing() end)

	local line1 = sizer_se:CreateTexture(nil, "BACKGROUND")
	line1:SetWidth(14)
	line1:SetHeight(14)
	line1:SetPoint("BOTTOMRIGHT", -8, 8)
	line1:SetTexture("Interface\\Tooltips\\UI-Tooltip-Border")
	local x = 0.1 * 14/17
	line1:SetTexCoord(0.05 - x, 0.5, 0.05, 0.5 + x, 0.05, 0.5 - x, 0.5 + x, 0.5)

	local line2 = sizer_se:CreateTexture(nil, "BACKGROUND")
	line2:SetWidth(8)
	line2:SetHeight(8)
	line2:SetPoint("BOTTOMRIGHT", -8, 8)
	line2:SetTexture("Interface\\Tooltips\\UI-Tooltip-Border")
	local x = 0.1 * 8/17
	line2:SetTexCoord(0.05 - x, 0.5, 0.05, 0.5 + x, 0.05, 0.5 - x, 0.5 + x, 0.5)

	local sizer_s = CreateFrame("Frame",nil,frame)
	sizer_s:SetPoint("BOTTOMRIGHT",frame,"BOTTOMRIGHT",-25,0)
	sizer_s:SetPoint("BOTTOMLEFT",frame,"BOTTOMLEFT",0,0)
	sizer_s:SetHeight(25)
	sizer_s:EnableMouse()
	sizer_s:SetScript("OnMouseDown",function() frame:StartSizing() end)
	sizer_s:SetScript("OnMouseUp", function() frame:StopMovingOrSizing() end)
	
	local sizer_e = CreateFrame("Frame",nil,frame)
	sizer_e:SetPoint("BOTTOMRIGHT",frame,"BOTTOMRIGHT",0,25)
	sizer_e:SetPoint("TOPRIGHT",frame,"TOPRIGHT",0,0)
	sizer_e:SetWidth(25)
	sizer_e:EnableMouse()
	sizer_e:SetScript("OnMouseDown",function() frame:StartSizing() end)
	sizer_e:SetScript("OnMouseUp", function() frame:StopMovingOrSizing() end)
	
	Alert_BuffScrollFrame:Show()
	Alert_BuffScrollFrame:SetParent(frame)
	Alert_BuffScrollFrame:ClearAllPoints()
	Alert_BuffScrollFrame:SetPoint("TOPLEFT", frame, "TOPLEFT", 20, -23)
	Alert_BuffScrollFrame:SetWidth(frame:GetWidth() -60)
	Alert_BuffScrollFrame:SetHeight(frame:GetHeight() -85)
	frame:SetScript("OnSizeChanged", function() Alert_BuffScrollFrame:SetWidth(frame:GetWidth() -60) Alert_BuffScrollFrame:SetHeight(frame:GetHeight() -85) end)
	
	frame:Hide()
	
	--SpellList Here
	
	local spellframe = CreateFrame("Frame","Alert_SpellFrame",UIParent)
	spellframe:SetWidth(250)
	spellframe:SetHeight(350)
	spellframe:SetPoint("CENTER",UIParent,"CENTER",0,0)
	spellframe:EnableMouse()
	spellframe:SetMovable(true)
	spellframe:SetResizable(true)
	spellframe:SetFrameStrata("FULLSCREEN_DIALOG")
	
	spellframe:SetBackdrop(FrameBackdrop)
	spellframe:SetBackdropColor(0,0,0,1)
	spellframe:SetMinResize(250,350)
	spellframe:SetToplevel(true)
	
	local spellclosebutton = CreateFrame("Button",'Alert_SellCloseButton',spellframe,"UIPanelButtonTemplate")
	spellclosebutton:SetScript("OnClick", function() spellframe:Hide() end)
	spellclosebutton:SetPoint("BOTTOMRIGHT",spellframe,"BOTTOMRIGHT",-27,17)
	spellclosebutton:SetHeight(20)
	spellclosebutton:SetWidth(100)
	spellclosebutton:SetText(CLOSE)
	
	local spellremovebutton = CreateFrame("Button",nil,spellframe,"UIPanelButtonTemplate")
	spellremovebutton:SetScript("OnClick", function() Alert:SpellRemove() end)
	spellremovebutton:SetPoint("BOTTOMRIGHT",spellframe,"BOTTOMRIGHT",-27,39)
	spellremovebutton:SetHeight(20)
	spellremovebutton:SetWidth(100)
	spellremovebutton:SetText("Remove")
	
	local spelleditbox = CreateFrame("EditBox", Alert_SpellEditBox, spellframe, "InputBoxTemplate")
	spelleditbox:SetPoint("BOTTOMLEFT",spellframe,"BOTTOMLEFT",22,39)
	spelleditbox:SetPoint("BOTTOMRIGHT",spellframe,"BOTTOMRIGHT",-133,39)
	spelleditbox:SetHeight(20)
	spelleditbox:SetAutoFocus(false)
	spelleditbox:SetScript("OnEscapePressed", function() spelleditbox:ClearFocus() end)
	spelleditbox:SetScript("OnEnterPressed", function() local val = spelleditbox:GetText() spelleditbox:SetText("") spelleditbox:ClearFocus() if val ~= "" then return Alert:SpellEntry(val) end end)
	
	local spellstatusbg = CreateFrame("Frame",nil,spellframe)
	spellstatusbg:SetPoint("BOTTOMLEFT",spellframe,"BOTTOMLEFT",15,15)
	spellstatusbg:SetPoint("BOTTOMRIGHT",spellframe,"BOTTOMRIGHT",-132,15)
	spellstatusbg:SetHeight(24)
	spellstatusbg:SetBackdrop(PaneBackdrop)
	spellstatusbg:SetBackdropColor(0.1,0.1,0.1)
	spellstatusbg:SetBackdropBorderColor(0.4,0.4,0.4)

	local spellstatustext = spellstatusbg:CreateFontString(nil,"OVERLAY","GameFontNormal")
	spellstatustext:SetPoint("TOPLEFT",spellstatusbg,"TOPLEFT",7,-2)
	spellstatustext:SetPoint("BOTTOMRIGHT",spellstatusbg,"BOTTOMRIGHT",-7,2)
	spellstatustext:SetHeight(20)
	spellstatustext:SetJustifyH("LEFT")
	spellstatustext:SetText("")
	
	local spelltitle = CreateFrame("Frame",nil,spellframe)
	spelltitle:EnableMouse()
	spelltitle:SetScript("OnMouseDown", function() spellframe:StartMoving() end)
	spelltitle:SetScript("OnMouseUp", function() spellframe:StopMovingOrSizing() end)
	
	
	local spelltitlebg = spellframe:CreateTexture(nil,"OVERLAY")
	spelltitlebg:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header")
	spelltitlebg:SetTexCoord(0.31,0.67,0,0.63)
	spelltitlebg:SetPoint("TOP",spellframe,"TOP",0,12)
	spelltitlebg:SetWidth(100)
	spelltitlebg:SetHeight(40)

	local spelltitlebg_l = spellframe:CreateTexture(nil,"OVERLAY")
	spelltitlebg_l:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header")
	spelltitlebg_l:SetTexCoord(0.21,0.31,0,0.63)
	spelltitlebg_l:SetPoint("RIGHT",spelltitlebg,"LEFT",0,0)
	spelltitlebg_l:SetWidth(30)
	spelltitlebg_l:SetHeight(40)
	
	local spelltitlebg_right = spellframe:CreateTexture(nil,"OVERLAY")
	spelltitlebg_right:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header")
	spelltitlebg_right:SetTexCoord(0.67,0.77,0,0.63)
	spelltitlebg_right:SetPoint("LEFT",spelltitlebg,"RIGHT",0,0)
	spelltitlebg_right:SetWidth(30)
	spelltitlebg_right:SetHeight(40)
	
	spelltitle:SetAllPoints(spelltitlebg)			
	local spelltitletext = spelltitle:CreateFontString(nil,"OVERLAY","GameFontNormal")
	spelltitletext:SetPoint("TOP",spelltitlebg,"TOP",0,-14)
	spelltitletext:SetText("Spells")
	
	local spellsizer_se = CreateFrame("Frame",nil,spellframe)
	spellsizer_se:SetPoint("BOTTOMRIGHT",spellframe,"BOTTOMRIGHT",0,0)
	spellsizer_se:SetWidth(25)
	spellsizer_se:SetHeight(25)
	spellsizer_se:EnableMouse()
	spellsizer_se:SetScript("OnMouseDown", function() spellframe:StartSizing() end)
	spellsizer_se:SetScript("OnMouseUp", function() spellframe:StopMovingOrSizing() end)

	local spellline1 = spellsizer_se:CreateTexture(nil, "BACKGROUND")
	spellline1:SetWidth(14)
	spellline1:SetHeight(14)
	spellline1:SetPoint("BOTTOMRIGHT", -8, 8)
	spellline1:SetTexture("Interface\\Tooltips\\UI-Tooltip-Border")
	local x = 0.1 * 14/17
	spellline1:SetTexCoord(0.05 - x, 0.5, 0.05, 0.5 + x, 0.05, 0.5 - x, 0.5 + x, 0.5)

	local spellline2 = spellsizer_se:CreateTexture(nil, "BACKGROUND")
	spellline2:SetWidth(8)
	spellline2:SetHeight(8)
	spellline2:SetPoint("BOTTOMRIGHT", -8, 8)
	spellline2:SetTexture("Interface\\Tooltips\\UI-Tooltip-Border")
	local x = 0.1 * 8/17
	spellline2:SetTexCoord(0.05 - x, 0.5, 0.05, 0.5 + x, 0.05, 0.5 - x, 0.5 + x, 0.5)

	local spellsizer_s = CreateFrame("Frame",nil,spellframe)
	spellsizer_s:SetPoint("BOTTOMRIGHT",spellframe,"BOTTOMRIGHT",-25,0)
	spellsizer_s:SetPoint("BOTTOMLEFT",spellframe,"BOTTOMLEFT",0,0)
	spellsizer_s:SetHeight(25)
	spellsizer_s:EnableMouse()
	spellsizer_s:SetScript("OnMouseDown",function() spellframe:StartSizing() end)
	spellsizer_s:SetScript("OnMouseUp", function() spellframe:StopMovingOrSizing() end)
	
	local spellsizer_e = CreateFrame("Frame",nil,spellframe)
	spellsizer_e:SetPoint("BOTTOMRIGHT",spellframe,"BOTTOMRIGHT",0,25)
	spellsizer_e:SetPoint("TOPRIGHT",spellframe,"TOPRIGHT",0,0)
	spellsizer_e:SetWidth(25)
	spellsizer_e:EnableMouse()
	spellsizer_e:SetScript("OnMouseDown",function() spellframe:StartSizing() end)
	spellsizer_e:SetScript("OnMouseUp", function() spellframe:StopMovingOrSizing() end)
	
	Alert_SpellScrollFrame:Show()
	Alert_SpellScrollFrame:SetParent(spellframe)
	Alert_SpellScrollFrame:ClearAllPoints()
	Alert_SpellScrollFrame:SetPoint("TOPLEFT", spellframe, "TOPLEFT", 20, -23)
	Alert_SpellScrollFrame:SetWidth(spellframe:GetWidth() -60)
	Alert_SpellScrollFrame:SetHeight(spellframe:GetHeight() -85)
	spellframe:SetScript("OnSizeChanged", function() Alert_SpellScrollFrame:SetWidth(spellframe:GetWidth() -60) Alert_SpellScrollFrame:SetHeight(spellframe:GetHeight() -85) end)
	
	spellframe:Hide()
end

function Alert:SetUpIconFrames()
	-- Called on initialize, sets up icon frames that will be used later.
	CreateFrame("FRAME", "Alert_IconTemplate", UIParent)  --< Invisible, used as an anchor for all other frames in this group >--
	Alert_IconTemplate:SetClampedToScreen(true)
	Alert_IconTemplate:SetWidth(50)
	Alert_IconTemplate:SetHeight(50)
	-- Alert_IconTemplate:SetPoint("CENTER", UIParent, "CENTER", self.db.profile.Options.IconX, self.db.profile.Options.IconY) 
	Alert_IconTemplate:SetScript("OnMouseDown",function()
		Alert_IconTemplate:StartMoving()
		-- Alert_IconUsableTemplate:StartMoving()
	end)
	Alert_IconTemplate:SetScript("OnMouseUp",function()
		Alert_IconTemplate:StopMovingOrSizing() 
		-- Alert_IconUsableTemplate:StopMovingOrSizing()
	end)
	Alert_IconTemplate:EnableMouse(true)
	
	Alert_IconTemplate:CreateTexture("Alert_Texture") --< This is the texture that is shown when icon possitoins are not locked, used only to see where the frame group currently is >--
	Alert_Texture:SetAllPoints(Alert_IconTemplate)
	Alert_Texture:SetTexture(0,0,0,0.5)
	Alert_IconTemplate:SetMovable(true)
	
	for a = 1,3 do --< This loop sets up the first three actual frames and their textures used to show icons, more will be created on the fly if needed >--
		frame = CreateFrame("FRAME", "Alert_Frame"..a, Alert_IconTemplate)
		local texture = frame:CreateTexture("Alert_Texture"..a)
		frame:ClearAllPoints()
		local font = frame:CreateFontString("Alert_Fontstring"..a, "ARTWORK", "GameFontNormal")
		font:SetPoint("BOTTOM", frame, "TOP", 0, 10)
		texture:ClearAllPoints()
		texture:SetAllPoints(frame)
		if a == 1 then
			frame:SetAllPoints(Alert_IconTemplate)
		else 
			frame:SetPoint("RIGHT", TextureList[a-1], "LEFT", -3, 0)
			frame:SetHeight(Alert_IconTemplate:GetHeight())
			frame:SetWidth(Alert_IconTemplate:GetWidth())
		end
		table.insert(FrameList, frame)
		table.insert(FontList, font)
		table.insert(TextureList, texture) 	--< We put the frames into a table so they can be refrenced and counted easily later >--
	end
end



function Alert:SetUpBuffListFrame()
	-- Also called on initialize, sets up the buff list in configuration.
	local ScrollFrame = CreateFrame("SCROLLFRAME", "Alert_BuffScrollFrame", UIParent, "UIPanelScrollFrameTemplate") --< This one is the main scrolling frame that holds the list >--
	ScrollFrame:SetPoint("CENTER", UIParent, "CENTER")
	ScrollFrame:SetFrameStrata("HIGH")
	ScrollFrame:SetFrameLevel(100)
	ScrollFrame:SetWidth(190)
	ScrollFrame:SetHeight(280)
	local ScrollFrameChild = CreateFrame("FRAME", "Alert_BuffScrollFrameChild", InterfaceOptionsFramePanelContainer) -- This is the frame that will be scrolled by the scrolling frame, and will contain all the buffs >--
	ScrollFrameChild:SetWidth(InterfaceOptionsFramePanelContainer:GetWidth())
	ScrollFrameChild:SetHeight(InterfaceOptionsFramePanelContainer:GetHeight())
	ScrollFrameChild:CreateTexture("testtexture")
	ScrollFrame:SetScrollChild(ScrollFrameChild)
	Alert:ProcEntryListSetup()
end

function Alert:SetUpSpellListFrame()
	-- Also called on initialize, sets up the buff list in configuration.
	local ScrollFrame = CreateFrame("SCROLLFRAME", "Alert_SpellScrollFrame", UIParent, "UIPanelScrollFrameTemplate") --< This one is the main scrolling frame that holds the list >--
	ScrollFrame:SetPoint("CENTER", UIParent, "CENTER")
	ScrollFrame:SetFrameStrata("HIGH")
	ScrollFrame:SetFrameLevel(100)
	ScrollFrame:SetWidth(190)
	ScrollFrame:SetHeight(280)
	local ScrollFrameChild = CreateFrame("FRAME", "Alert_SpellScrollFrameChild", InterfaceOptionsFramePanelContainer) -- This is the frame that will be scrolled by the scrolling frame, and will contain all the buffs >--
	ScrollFrameChild:SetWidth(InterfaceOptionsFramePanelContainer:GetWidth())
	ScrollFrameChild:SetHeight(InterfaceOptionsFramePanelContainer:GetHeight())
	ScrollFrameChild:CreateTexture("testtexture")
	ScrollFrame:SetScrollChild(ScrollFrameChild)
	Alert:SpellEntryListSetup()
end

function Alert:SpellEntryListSetup()
	-- Called on initialize and when spells are added or removed from the list
	Alert_SpellScrollFrame:Show()
	if SpellSetup == nil then
		y = 17
		local i = 0
		for k,v in pairs(Alert_SpellList) do --< This loop basically scrolls through the main buff list, creates a list entry if there is not an empty one, and reassigns existing entries, then inserts them into a table for easy access >--
			i = i+1
			y = y-17
			if SpellEntryTable[k] == nil then
				local line = CreateFrame("BUTTON", "Alert_SpellEntry"..k, Alert_SpellScrollFrameChild, "Alert_SpellEntryTemplate")
				line:ClearAllPoints()
				line:SetPoint("TOPLEFT", Alert_SpellScrollFrameChild, "TOPLEFT", 0, y)
				line:SetWidth(Alert_SpellScrollFrameChild:GetWidth())
				local lineText = line:CreateFontString((line:GetName()).."Text", "ARTWORK", "GameFontHighlightSmall")
				lineText:SetPoint("LEFT", line, "LEFT", 1, 0)
				lineText:SetText(v)
				table.insert(SpellEntryTable, line)
				table.insert(SpellEntryTextTable, lineText)
			else
				SpellEntryTextTable[k]:SetText(v)
				SpellEntryTable[k]:Show()
			end
		end
		--< These resize the scroll frame child appropriatly according to the number of entries >--
		if (Alert_SpellScrollFrame:GetTop()+ (y-17) > Alert_SpellScrollFrame:GetBottom()) then
			Alert_SpellScrollFrameChild:SetHeight(Alert_SpellScrollFrame:GetHeight())
		end
		if (Alert_SpellScrollFrame:GetTop()+ (y-17) <= Alert_SpellScrollFrame:GetBottom()) then
			Alert_SpellScrollFrameChild:SetHeight((17*i)+5)
		end
		SpellSetup = true
	end
	if SpellSetupSelected == nil then --< This sets up the texture that will be shown behind selected entries >--
		Alert_SpellScrollFrame:CreateTexture("Alert_SpellSelectedTexture")
		Alert_SpellSelectedTexture:SetTexture("Interface\\HelpFrame\\HelpFrameButton-Highlight")
		Alert_SpellSelectedTexture:SetTexCoord(0.15, 0.6, 0, 0.25)
		Alert_SpellSelectedTexture:SetWidth(Alert_SpellScrollFrameChild:GetWidth()-10)
		Alert_SpellSelectedTexture:SetHeight(16)
		Alert_SpellSelectedTexture:SetBlendMode("ADD")
		Alert_SpellSelectedTexture:SetParent(Alert_SpellScrollFrameChild)
		Alert_SpellSelectedTexture:Hide()
		SpellSetupSelected = true
	end
end

function Alert:ProcEntryListSetup()
	-- Called on initialize and when buffs are added or removed from the list
	Alert_BuffScrollFrame:Show()
	if Setup == nil then
		y = 17
		local i = 0
		for k,v in pairs(Alert_ProcList) do --< This loop basically scrolls through the main buff list, creates a list entry if there is not an empty one, and reassigns existing entries, then inserts them into a table for easy access >--
			i = i+1
			y = y-17
			if ProcEntryTable[k] == nil then
				local line = CreateFrame("BUTTON", "Alert_ProcEntry"..k, Alert_BuffScrollFrameChild, "Alert_ProcEntryTemplate")
				line:ClearAllPoints()
				line:SetPoint("TOPLEFT", Alert_BuffScrollFrameChild, "TOPLEFT", 0, y)
				line:SetWidth(Alert_BuffScrollFrameChild:GetWidth())
				local lineText = line:CreateFontString((line:GetName()).."Text", "ARTWORK", "GameFontHighlightSmall")
				lineText:SetPoint("LEFT", line, "LEFT", 1, 0)
				lineText:SetText(v)
				local lineTextRight = line:CreateFontString((line:GetName()).."TextRight", "ARTWORK", "GameFontHighlightSmall")
				lineTextRight:SetPoint("LEFT", line, "LEFT", Alert_BuffScrollFrame:GetWidth()-17, 0)
				lineTextRight:SetTextColor(RAID_CLASS_COLORS["MAGE"].r, RAID_CLASS_COLORS["MAGE"].g, RAID_CLASS_COLORS["MAGE"].b)
				if Alert_Sound[k] == true then
					lineTextRight:SetText("<>")
				else
					lineTextRight:SetText("")
				end
				table.insert(ProcEntryTable, line)
				table.insert(ProcEntryTextRightTable, lineTextRight)
				table.insert(ProcEntryTextTable, lineText)
			else
				if Alert_Sound[k] == true then
					ProcEntryTextRightTable[k]:SetText("<>")
				else
					ProcEntryTextRightTable[k]:SetText("")
				end
				ProcEntryTextTable[k]:SetText(v)
				ProcEntryTable[k]:Show()
			end
		end
		--< These resize the scroll frame child appropriatly according to the number of entries >--
		if (Alert_BuffScrollFrame:GetTop()+ (y-17) > Alert_BuffScrollFrame:GetBottom()) then
			Alert_BuffScrollFrameChild:SetHeight(Alert_BuffScrollFrame:GetHeight())
		end
		if (Alert_BuffScrollFrame:GetTop()+ (y-17) <= Alert_BuffScrollFrame:GetBottom()) then
			Alert_BuffScrollFrameChild:SetHeight((17*i)+5)
		end
		Setup = true
	end
	if SetupSelected == nil then --< This sets up the texture that will be shown behind selected entries >--
		Alert_BuffScrollFrame:CreateTexture("Alert_SelectedTexture")
		Alert_SelectedTexture:SetTexture("Interface\\HelpFrame\\HelpFrameButton-Highlight")
		Alert_SelectedTexture:SetTexCoord(0.15, 0.6, 0, 0.25)
		Alert_SelectedTexture:SetWidth(Alert_BuffScrollFrameChild:GetWidth()-10)
		Alert_SelectedTexture:SetHeight(16)
		Alert_SelectedTexture:SetBlendMode("ADD")
		Alert_SelectedTexture:SetParent(Alert_BuffScrollFrameChild)
		Alert_SelectedTexture:Hide()
		SetupSelected = true
	end
end

function Alert_ProcEntryOnClick()
	-- Called when an entry on the list is clicked, gets the current entry and sets the selected texture behind it >--
	SelectedEntry = GetMouseFocus()
	Alert_SelectedTexture:Show()
	Alert_SelectedTexture:ClearAllPoints()
	Alert_SelectedTexture:SetPoint("TOPLEFT", GetMouseFocus(), "TOPLEFT")
end

function Alert_SpellEntryOnClick()
	-- Called when an entry on the list is clicked, gets the current entry and sets the selected texture behind it >--
	SpellSelectedEntry = GetMouseFocus()
	Alert_SpellSelectedTexture:Show()
	Alert_SpellSelectedTexture:ClearAllPoints()
	Alert_SpellSelectedTexture:SetPoint("TOPLEFT", GetMouseFocus(), "TOPLEFT")
end

function Alert_ProcEntryOnDoubleClick()
	-- Called when an entry on the list is double clicked
	for k,v in pairs(ProcEntryTable) do
		if SelectedEntry ~= nil and ProcEntryTable[k]:GetName() == SelectedEntry:GetName() then
			if Alert_Sound[k] == true then
				Alert_Sound[k] = false
				ProcEntryTextRightTable[k]:SetText("")
			else
				Alert_Sound[k] = true
				ProcEntryTextRightTable[k]:SetText("<>")
			end
			-- break
		end
	end
end

function Alert:Remove()
	-- Called when the Remove Entry button is pressed, cycles through all entries, hides the texture, clears the text, removes the selected one from the proc list, and calls the proc setup function
	for k,v in pairs(ProcEntryTable) do
		Alert_SelectedTexture:Hide()
		ProcEntryTable[k]:Hide()
		ProcEntryTextTable[k]:SetText("")
		if SelectedEntry ~= nil and ProcEntryTable[k]:GetName() == SelectedEntry:GetName() then
			table.remove(Alert_ProcList, k)
			table.remove(Alert_Sound, k)
			SelectedEntry = nil
		end
	end
	for k,v in pairs(Alert_ProcList) do
		Alert_Played[v] = false
	end
	Setup = nil
	Alert:ProcEntryListSetup()
end

function Alert:ProcEntry(val)
	-- Called when a new buff is entered, pretty much the same as the removal function, but adds an entry to the table instead of removing one.
	table.insert(Alert_ProcList, val)
	table.insert(Alert_Sound, true)
	for k,v in pairs(Alert_ProcList) do
		Alert_Played[v] = false
	end
	for k,v in pairs(ProcEntryTable) do
		Alert_SelectedTexture:Hide()
		ProcEntryTable[k]:Hide()
		ProcEntryTextTable[k]:SetText("")
	end
	Setup = nil
	Alert:ProcEntryListSetup()
end

function Alert:SpellRemove()
	-- Called when the Remove Entry button is pressed, cycles through all entries, hides the texture, clears the text, removes the selected one from the proc list, and calls the proc setup function
	for k,v in pairs(SpellEntryTable) do
		Alert_SpellSelectedTexture:Hide()
		SpellEntryTable[k]:Hide()
		SpellEntryTextTable[k]:SetText("")
		if SpellSelectedEntry ~= nil and SpellEntryTable[k]:GetName() == SpellSelectedEntry:GetName() then
			table.remove(Alert_SpellList, k)
			-- table.remove(Alert_Sound, k)
			SpellSelectedEntry = nil
		end
	end
	-- for k,v in pairs(Alert_SpellList) do
		-- Alert_Played[v] = false
	-- end
	SpellSetup = nil
	Alert:SpellEntryListSetup()
end

function Alert:SpellEntry(val)
	-- Called when a new buff is entered, pretty much the same as the removal function, but adds an entry to the table instead of removing one.
	table.insert(Alert_SpellList, val)
	-- table.insert(Alert_Sound, true)
	-- for k,v in pairs(Alert_SpellList) do
		-- Alert_Played[v] = false
	-- end
	for k,v in pairs(SpellEntryTable) do
		Alert_SpellSelectedTexture:Hide()
		SpellEntryTable[k]:Hide()
		SpellEntryTextTable[k]:SetText("")
	end
	SpellSetup = nil
	Alert:SpellEntryListSetup()
end

function Alert:SetUpUsableIconFrames()
	if not TextureListUsable then 
		TextureListUsable = {}
		FrameListUsable = {}
		FontListUsable = {}
	end
	-- Called on initialize, sets up icon frames that will be used later.
	CreateFrame("FRAME", "Alert_IconUsableTemplate", Alert_IconTemplate)  --< Invisible, used as an anchor for all other frames in this group >--
	Alert_IconUsableTemplate:SetClampedToScreen(true)
	Alert_IconUsableTemplate:SetWidth(50)
	Alert_IconUsableTemplate:SetHeight(50)
	-- Alert_IconUsableTemplate:SetScale(Alert_IconTemplate:GetScale())
	-- Alert_IconUsableTemplate:SetPoint("CENTER", UIParent, "CENTER", self.db.profile.Options.IconX, self.db.profile.Options.IconY) 
	Alert_IconUsableTemplate:SetScript("OnMouseDown",function()
		-- Alert_IconTemplate:StartMoving()
		-- Alert_IconUsableTemplate:StartMoving()
	end)
	Alert_IconUsableTemplate:SetScript("OnMouseUp",function()
		-- Alert_IconTemplate:StopMovingOrSizing() 
		-- Alert_IconUsableTemplate:StopMovingOrSizing()
	end)
	-- Alert_IconUsableTemplate:EnableMouse(true)
	
	Alert_IconUsableTemplate:CreateTexture("Alert_UsableTexture") --< This is the texture that is shown when icon possitoins are not locked, used only to see where the frame group currently is >--
	Alert_UsableTexture:SetAllPoints(Alert_IconUsableTemplate)
	Alert_UsableTexture:SetTexture(0,0,0,0.5)
	-- Alert_IconUsableTemplate:SetMovable(true)
	
	for a = 1,3 do --< This loop sets up the first three actual frames and their textures used to show icons, more will be created on the fly if needed >--
		frame = CreateFrame("FRAME", "Alert_UsableFrame"..a, Alert_IconUsableTemplate)
		local texture = frame:CreateTexture("Alert_UsableTexture"..a)
		frame:ClearAllPoints()
		local font = frame:CreateFontString("Alert_UsableFontstring"..a, "ARTWORK", "GameFontNormal")
		font:SetPoint("BOTTOM", frame, "TOP", 0, 10)
		texture:ClearAllPoints()
		texture:SetAllPoints(frame)
		if a == 1 then
			frame:SetAllPoints(Alert_IconUsableTemplate)
		else 
			frame:SetPoint("RIGHT", TextureListUsable[a-1], "LEFT", -3, 0)
			frame:SetHeight(Alert_IconUsableTemplate:GetHeight())
			frame:SetWidth(Alert_IconUsableTemplate:GetWidth())
		end
		table.insert(FrameListUsable, frame)
		table.insert(FontListUsable, font)
		table.insert(TextureListUsable, texture) 	--< We put the frames into a table so they can be refrenced and counted easily later >--
	end
	Alert_IconUsableTemplate:ClearAllPoints()
	Alert_IconUsableTemplate:SetPoint("CENTER", Alert_IconTemplate, "CENTER", 0, -70)
	Alert_IconTemplate:SetScript('OnUpdate', function(self, elapsed)
		if Alert.Time ~= nil then
			Alert.Time = Alert.Time + elapsed
		else
			Alert.Time = 1
		end
		if Alert.Time >= 0.4 then
			if Alert.db.profile.Options.SpellIcon == true then
				local TextureNumber = 0	
				local numBuffs = 0
				for k,v in pairs(Alert_SpellList) do
					local startTime, duration, _ = GetSpellCooldown(v)
					if duration ~= nil and duration <= 1.5 then
						TextureNumber = TextureNumber + 1
						if TextureListUsable[TextureNumber] ~= nil then
							local buffName, _,Alert_Icon,_,_, _, _,_,_,_,_ = GetSpellInfo(v)
							TextureListUsable[TextureNumber]:SetTexture(Alert_Icon)
						end
						if TextureList[TextureNumber] == nil then
							local frame = CreateFrame("FRAME", "Alert_UsableFrame"..TextureNumber, Alert_IconUsableTemplate)
							local texture = frame:CreateTexture("Alert_UsableTexture"..TextureNumber)
							local font = frame:CreateFontString("Alert_UsableFontstring"..TextureNumber, "ARTWORK", "GameFontNormal")
							font:SetPoint("BOTTOM", frame, "TOP", 0, 10)
							frame:ClearAllPoints()
							texture:ClearAllPoints()
							texture:SetAllPoints(frame)
							if TextureNumber == 1 then
								frame:SetAllPoints(Alert_IconUsableTemplate)
							else 
								frame:SetPoint("RIGHT", TextureListUsable[TextureNumber-1], "LEFT", -1, 0)
								frame:SetHeight(Alert_IconUsableTemplate:GetHeight())
								frame:SetWidth(Alert_IconUsableTemplate:GetWidth())
							end
							local buffName, _,Alert_Icon,_,_, duration, expTime,_,_,_,_ = GetSpellInfo(v)
							texture:SetTexture(Alert_Icon)
							table.insert(FrameListUsable, frame)
							table.insert(FontListUsable, font)
							table.insert(TextureListUsable, texture)
						end
					end
				end
				TextureNumber = TextureNumber + 1
				for k = TextureNumber, #TextureListUsable do
					if TextureListUsable[k] then
						TextureListUsable[k]:SetTexture(nil)
					end
				end
			else
				for k,v in pairs(TextureListUsable) do
					TextureListUsable[k]:SetTexture(nil)
				end
			end
			Alert.Time = 0
		end
	end)
end

function Alert:UNIT_AURA(arg1, arg2)
	-- The real meat of the addon, called when the player or anyone nearby gains or looses an aura
	if arg2 == "player" then  -- who even cares about anyone else ?
		BuffActiveList = {}
		BuffIcons = {}
		local count = 0
		for k,v in pairs(Alert_ProcList) do --< Cycle through the proc list, look for the buffs defined on it, if the buff is there, play sound, show text, and call icon function depending on options defined by user >--
			buffName, _,Alert_Icon,_,_, duration, expTime,_,_,_,_ = UnitAura("player", v)
			if buffName == nil then
				Alert_Played[v] = false
			end
			count = count + 1
			if buffName == nil then
				table.insert(BuffIcons, "nil"..count)
				table.insert(BuffActiveList, "nil"..count)
			else
				table.insert(BuffIcons, Alert_Icon)
				table.insert(BuffActiveList, buffName)
			end
			if buffName ~= nil then 
				Time = floor(GetTime())
				expTime = floor(expTime)
				if duration+Time == expTime then
					if playtime == Time then
						return
					end
					if Alert_Played[v] == false then
						if Alert_Sound[k] == true then
							if self.db.profile.Options.Sound == true then
								PlaySoundFile(self.db.profile.Options.ProcSound)
							end
						end
						if self.db.profile.Options.Text == true then
							DEFAULT_CHAT_FRAME:AddMessage(v,.6,.8,.8) 
							DEFAULT_CHAT_FRAME:AddMessage("--------------------------",.6,.8,.8)
						end
						Alert_Played[v] = true
					end
					playtime = Time
				end
			end
		end
		if self.db.profile.Options.Icon == true then
			Alert:IconHandling();
		end
	end
end

function Alert:IconHandling()
	-- Called by the above function if icons should be shown, simply sets the appropriate texture to the appropriate icon, and if there are not enough available textures / frames, creates a new one.
	TextureNumber = 0	
	for k,v in pairs(TextureList) do
		TextureList[k]:SetTexture(nil)
		FrameList[k].buff = nil
		if FrameList[k].buffName == nil and FrameList[k].font ~= nil then
			FrameList[k]:SetScript("OnUpdate", nil)
			for k,v in pairs(FontList) do
				v:SetText("")
			end
		end
	end
	for k,v in pairs(Alert_ProcList) do
		if strlower(BuffActiveList[k]) == strlower(Alert_ProcList[k]) then
			TextureNumber = TextureNumber + 1
			if TextureList[TextureNumber] ~= nil then
				TextureList[TextureNumber]:SetTexture(BuffIcons[k])
				FrameList[TextureNumber].buff = v
				FrameList[TextureNumber].font = FontList[TextureNumber]
				local buffName, _,Alert_Icon,_,_, duration, expTime,_,_,_,_ = UnitAura("player", FrameList[TextureNumber].buff)
				FrameList[TextureNumber].buffName = buffName
			end
			if TextureList[TextureNumber] == nil then
				local frame = CreateFrame("FRAME", "Alert_Frame"..TextureNumber, Alert_IconTemplate)
				local texture = frame:CreateTexture("Alert_Texture"..TextureNumber)
				local font = frame:CreateFontString("Alert_Fontstring"..TextureNumber, "ARTWORK", "GameFontNormal")
				font:SetPoint("BOTTOM", frame, "TOP", 0, 10)
				frame:ClearAllPoints()
				texture:ClearAllPoints()
				texture:SetAllPoints(frame)
				if TextureNumber == 1 then
					frame:SetAllPoints(Alert_IconTemplate)
				else 
					frame:SetPoint("RIGHT", TextureList[TextureNumber-1], "LEFT", -1, 0)
					frame:SetHeight(Alert_IconTemplate:GetHeight())
					frame:SetWidth(Alert_IconTemplate:GetWidth())
				end
				TextureNumber = TextureNumber + 1
				texture:SetTexture(BuffIcons[k])
				table.insert(FrameList, frame)
				table.insert(FontList, font)
				table.insert(TextureList, texture)
			end
		end
	end
	if Alert.db.profile.Options.Timer == true then
		for k,v in pairs(TextureList) do
			if TextureList[k]:GetTexture() == nil then
				FontList[k]:SetText("")
			end
			if TextureList[k]:GetTexture() ~= nil then
				if FrameList[k]:GetScript("OnUpdate") == nil then
					if FrameList[k].ela == nil then
						FrameList[k].ela = 0
					end
					FrameList[k]:SetScript("OnUpdate", function(self, elapsed)
						self.ela = self.ela + elapsed
						if self.ela >= 0.1 then
							self.ela = 0
							for k,v in pairs(TextureList) do
								if FrameList[k].buff ~= nil then
									local buffName, _,Alert_Icon,_,_, duration, expTime,_,_,_,_ = UnitAura("player", FrameList[k].buff)
									if buffName ~= nil then
										if (expTime - GetTime()) <= 60 and (expTime - GetTime()) >= 0.2 then
											FontList[k]:SetText(ceil(expTime - GetTime()))
										elseif (expTime - GetTime()) < 0.2 then
											FontList[k]:SetText("")
										else 
											FontList[k]:SetText("")
										end
									else
										FontList[k]:SetText(nil)
									end
								else 
									FontList[k]:SetText(nil)
								end
							end
						end
					end)
				end
				return
			end
		end		
	end
end

function Alert:ChatCommand(input)
	-- Called when a chat command is input with /alert
    if not input or input:trim() == "" then
        InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
    end
end